<!doctype html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'} ">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-row layui-col-space15">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item" placeholder="输入关键字">
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="startTime" class="layui-input search-item" placeholder="开始时间" readonly>
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="endTime" class="layui-input search-item" placeholder="结束时间" readonly>
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-sm" lay-event="saveEvent">
                                <i class="fa fa-lg fa-plus"></i> 新增
                            </button>
                            <button type="button" class="layui-btn layui-btn-normal layui-btn-sm" lay-event="updateEvent">
                                <i class="fa fa-lg fa-edit"></i> 编辑
                            </button>
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="removeEvent">
                                <i class="fa fa-lg fa-trash"></i> 删除
                            </button>
                        </div>
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>
<input type="hidden" id="tableName" th:value="${tableName}"/>
<input type="hidden" id="uuidField" th:value="${uuidField}"/>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script src="assets/js/vendor/viewer/viewer.min.js"></script>
<script th:inline="javascript">
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate', 'common'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var laydate = layui.laydate;
        var common = layui.common;
        var resizeTimeout = null;
        var defaultCols = [[${dynamicListFormShowFieldDTOList}]];

        // 初始化表格
        function initTable() {
            var autoCols = [
                {type:'checkbox', fixed: 'left'},
                {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'}
            ];
            for(var i = 0, item = defaultCols[i]; item = defaultCols[i++];) {
                if(item.fieldType === 'file' || item.fieldType === 'image' || item.fieldType === 'video' || item.fieldType === 'audio') {
                    autoCols.push({field: (item.fieldName), width: item.fieldWidth, title: item.fieldExplain, align:'center',
                        templet: function(row) {
                            var selectData = row[this.field];
                            if(typeof(selectData) === 'undefined' || selectData == null || selectData == '') {
                                return '-';
                            }
                            var downloadFile = '';
                            var datas = selectData.split(',');
                            for(var i = 0, item = datas[i]; item = datas[i++];) {
                                if(downloadFile.length > 0) {
                                    downloadFile += ' | ';
                                }
                                downloadFile += '<a href="route/file/downloadfile/false/'+ item +'" target="_blank">点击下载</a>'
                            }
                            return downloadFile;
                        }
                    });
                } else if(item.fieldType === 'date') {
                    autoCols.push({field: (item.fieldName), width: item.fieldWidth, title: item.fieldExplain, align:'center',
                        templet: function(row) {
                            var selectData = row[this.field];
                            if(typeof(selectData) === 'undefined' || selectData == null || selectData == '') {
                                return '-';
                            }
                            return common.formatDate('yyyy-MM-dd', new Date(selectData));
                        }
                    });
                } else if(item.fieldType === 'datetime') {
                    autoCols.push({field: (item.fieldName), width: item.fieldWidth, title: item.fieldExplain, align:'center',
                        templet: function(row) {
                            var selectData = row[this.field];
                            if(typeof(selectData) === 'undefined' || selectData == null || selectData == '') {
                                return '-';
                            }
                            return common.formatDate('yyyy-MM-dd hh:mm:ss', new Date(selectData));
                        }
                    });
                } else if(item.fieldType === 'select' || item.fieldType === 'radio' || item.fieldType === 'checkbox') {
                    autoCols.push({field: (item.fieldName +'DictionaryName'), width: item.fieldWidth, title: item.fieldExplain, align:'center',
                        templet: function(row) {
                            var selectData = row[this.field];
                            if(typeof(selectData) === 'undefined' || selectData == null || selectData == '') {
                                return '-';
                            }
                            return selectData;
                        }
                    });
                } else if(item.fieldType === 'selectUser') {
                    autoCols.push({field: item.fieldName, width: item.fieldWidth, title: item.fieldExplain, align:'center',
                        templet: function(row) {
                            var selectData = row[this.field];
                            if(typeof(selectData) === 'undefined' || selectData == null || selectData == '') {
                                return '-';
                            }
                            var selectArray = selectData.split(',');
                            var value = '';
                            for(var i = 0, item = selectArray[i]; item = selectArray[i++];) {
                                var info = item.split('|');
                                if(value.length > 0) {
                                    value += ',';
                                }
                                value += info[3];
                            }
                            return value;
                        }
                    });
                } else if(item.fieldType === 'selectDepartment') {
                    autoCols.push({field: item.fieldName, width: item.fieldWidth, title: item.fieldExplain, align:'center',
                        templet: function(row) {
                            var selectData = row[this.field];
                            if(typeof(selectData) === 'undefined' || selectData == null || selectData == '') {
                                return '-';
                            }
                            var selectArray = selectData.split(',');
                            var value = '';
                            for(var i = 0, item = selectArray[i]; item = selectArray[i++];) {
                                var info = item.split('|');
                                if(value.length > 0) {
                                    value += ',';
                                }
                                value += info[1];
                            }
                            return value;
                        }
                    });
                } else if(item.fieldType === 'currentUser'
                    || item.fieldType === 'currentDepartment'
                    || item.fieldType === 'currentRole'
                    || item.fieldType === 'currentGroup'
                    || item.fieldType === 'currentPosition') {
                    autoCols.push({field: item.fieldName, width: item.fieldWidth, title: item.fieldExplain, align:'center',
                        templet: function(row) {
                            var currentData = row[this.field];
                            if(typeof(currentData) === 'undefined' || currentData == null || currentData == '') {
                                return '-';
                            }
                            return currentData != null && currentData != '' ? currentData.split('|')[1] : '无';
                        }
                    });
                } else {
                    autoCols.push({field: item.fieldName, width: item.fieldWidth, title: item.fieldExplain, align:'center',
                        templet: function(row) {
                            var selectData = row[this.field];
                            if(typeof(selectData) === 'undefined' || selectData == null || selectData == '') {
                                return '-';
                            }
                            return selectData;
                        }
                    });
                }
            }
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path('api/dynamicdata/listpagedynamicdata/{tableName}', [$('#tableName').val()]),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 90,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [autoCols],
                page: true,
                parseData: function(data) {
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable() {
            table.reload('dataTable', {
                url: top.restAjax.path('api/dynamicdata/listpagedynamicdata/{tableName}', [$('#tableName').val()]),
                where: {
                    keywords: $('#keywords').val(),
                    startTime: $('#startTime').val(),
                    endTime: $('#endTime').val()
                },
                height: $win.height() - 90,
            });
        }
        // 初始化日期
        function initDate() {
            // 日期选择
            laydate.render({
                elem: '#startTime',
                format: 'yyyy-MM-dd'
            });
            laydate.render({
                elem: '#endTime',
                format: 'yyyy-MM-dd'
            });
        }
        // 删除
        function removeData(ids) {
            top.dialog.msg(top.dataMessage.delete, {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
                yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/dynamicdata/removedynamicdata/{tableName}/{ids}', [$('#tableName').val(), ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000}, function () {
                            reloadTable();
                        });
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }
            });
        }
        initTable();
        initDate();
        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable();
        });
        // 事件 - 增删改
        table.on('toolbar(dataTable)', function(obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if(layEvent === 'saveEvent') {
                layer.open({
                    type: 2,
                    title: false,
                    closeBtn: 0,
                    area: ['100%', '100%'],
                    shadeClose: true,
                    anim: 2,
                    content: top.restAjax.path('route/dynamicform/savedynamicform/{tableName}', [$('#tableName').val()]),
                    end: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'updateEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectEdit);
                } else if(checkDatas.length > 1) {
                    top.dialog.msg(top.dataMessage.table.selectOneEdit);
                } else {
                    layer.open({
                        type: 2,
                        title: false,
                        closeBtn: 0,
                        area: ['100%', '100%'],
                        shadeClose: true,
                        anim: 2,
                        content: top.restAjax.path('route/dynamicform/updatedynamicform/{tableName}/{uuidValue}', [$('#tableName').val(), checkDatas[0][$('#uuidField').val()]]),
                        end: function() {
                            reloadTable();
                        }
                    });
                }
            } else if(layEvent === 'removeEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectDelete);
                } else {
                    var ids = '';
                    for(var i = 0, item; item = checkDatas[i++];) {
                        if(i > 1) {
                            ids += '_';
                        }
                        ids += item[$('#uuidField').val()];
                    }
                    removeData(ids);
                }
            }
        });
    });
</script>
</body>
</html>